<?php

class Gateway_Ipasspay_PaymentController extends Mage_Core_Controller_Front_Action {
	protected $_order;
	protected $_orderId;
	protected $_bankMsg;
	protected function _expireAjax() {
		if (!Mage::getSingleton('checkout/session')->getQuote()->hasItems()) {
			$this->getResponse()->setHeader('HTTP/1.1', '403 Session Expired');
			exit();
		}
	}
	public function getOrder() {
		if ($this->_order == null) {
			$session = Mage::getSingleton('checkout/session');
			$this->_order = Mage::getModel('sales/order');
			$this->_order->loadByIncrementId($session->getLastRealOrderId());
		}
		return $this->_order;
	}
	public function getCheckout() {
		return Mage::getSingleton('checkout/session');
	}
	public function redirectAction() {

	    $order = $this->getOrder();
		$session = $this->getCheckout();
		$session->setIpasspayPaymentQuoteId($session->getQuoteId());
		$model = Mage::getModel('ipasspay/payment');
		$order = $this->getOrder();

		if (!$order->getId()) {
			$this->norouteAction();
			return;
		}
		$order->addStatusToHistory($order->getStatus(), Mage::helper('ipasspay')->__('Customer was redirected to ipasspay'), false);
		$order->save();
		$this->loadLayout();
		$this->getLayout()->getBlock('root')->setTemplate('page/1column.phtml');
		$this->getLayout()->getBlock('content')->append($this->getLayout()->createBlock('ipasspay/redirect'));
		$this->renderLayout();
		$session->unsQuoteId();

	}
	public function returnAction() {

		if (empty($_POST)) {
			$this->_redirect('checkout/onepage/failure');
			return false;
		}
		$model = Mage::getModel('ipasspay/payment');
		if ($_POST['status'] == 0) {
			Mage::getSingleton("customer/session")->addError($this->__($_POST['info']));
			Mage::getSingleton("core/session")->addError($this->__($_POST['info']));
			Mage::getSingleton("checkout/session")->addError($this->__($_POST['info']));
			$this->_redirect('sales/order/reorder/order_id/' . $_POST['oid1']);
			return false;
		} elseif ($_POST['status'] == 1) {

			$order_status = $_POST['order_status']; //订单状态
			$oid = $_POST['oid']; //商户的订单号
			$pid = $_POST['pid']; //ipasspay平台的订单号
			$Amount = $_POST['Amount'];
			$currency = $_POST['currency']; //交易货币
			$hash_info = $_POST['hash_info']; //交易的加密信息
			$notification_url = $_POST['notification_url']; //网站即时通知URL)
			$info = $_POST['info']; //此时"info"字段的值为该笔交易失败的原因说明

			$mid = $model->getConfigData('mid');
			$site_id = $model->getConfigData('siteid');
			$api_key = $model->getConfigData('md5key');

			$getsignature = hash("sha256", $mid . $site_id .
				$oid . $Amount . $currency . $api_key);

			if ($getsignature != $hash_info) {
				Mage::getSingleton("customer/session")->addError($this->__('invalid hash info'));
				Mage::getSingleton("core/session")->addError($this->__('invalid hash info'));
				Mage::getSingleton("checkout/session")->addError($this->__('invalid hash info'));
				$this->_redirect('sales/order/reorder/order_id/' . $_POST['oid1']);
				return false;
			}

			$order = Mage::getModel('sales/order')->loadByIncrementId($oid);
			switch ($order_status) {
			case 2: // success

				Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
				$order->addStatusToHistory(
					$model->getConfigData('order_status_payment_success'),
					Mage::helper('ipasspay')->__('Payment succeed!')
				);
				//$order->setState($model->getConfigData('order_status_payment_success'), true);
				$order->save();
				//var_dump($_POST);
				//exit;
				$this->_redirect('checkout/onepage/success');
				break;

            case 1: // pending

                Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
                $order->addStatusToHistory(
                    $model->getConfigData('order_status_payment_pending'),
                    Mage::helper('ipasspay')->__('Payment pending!')
                );
                //$order->setState($model->getConfigData('order_status_payment_success'), true);
                $order->save();
                //var_dump($_POST);
                //exit;
                $this->_redirect('checkout/onepage/success');
                break;

            case 3: // authorized

                Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
                $order->addStatusToHistory(
                    $model->getConfigData('order_status_payment_authroized'),
                    Mage::helper('ipasspay')->__('Payment authroized!')
                );
                //$order->setState($model->getConfigData('order_status_payment_success'), true);
                $order->save();
                //var_dump($_POST);
                //exit;
                $this->_redirect('checkout/onepage/success');
                break;

			case 6: // declined
				// error message
				Mage::getSingleton("customer/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("core/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("checkout/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				$order->addStatusToHistory(
					$model->getConfigData('order_status'),
					Mage::helper('ipasspay')->__('Payment failed!')
				);
				$order->save();
				$this->_redirect('checkout/onepage/failure');
				break;
			default:
				// error message
				Mage::getSingleton("customer/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("core/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("checkout/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				$this->_redirect('checkout/onepage/failure');
			}

		} else {
			Mage::getSingleton("customer/session")->addError($this->__("Error processing,please try again."));
			Mage::getSingleton("core/session")->addError($this->__("Error processing,please try again."));
			Mage::getSingleton("checkout/session")->addError($this->__("Error processing,please try again."));
			$this->_redirect('checkout/onepage/failure');
			return false;
		}

	}
	public function notifyAction() {
	    // asynchronous notification
	    $result['status'] = "100";
	    echo json_encode($result);exit();
		exit("100");
		$model = Mage::getModel('ipasspay/payment');
		if (!empty($_GET) && empty($_POST)) {
			$_POST = $_GET;
		}
		unset($_GET);
		if (empty($_POST)) {
			exit("error");
			return false;
		}
		$_GET = $_POST;
		$status = isset($_GET['status']) ? $_GET['status'] : "";
		if ($status == "0" || $status == null) {
			$message = $_GET['info'];
			if ($message == "") {
				$message = "Payment Failure";
			}
			$_SESSION['message'] = $message;
			die($message);
			return false;
		} else {
			$order_status = $_GET['order_status']; //订单状态
			$oid = $_GET['oid']; //商户的订单号
			$pid = $_GET['pid']; //udo平台的订单号
			$Amount = $_GET['Amount'];
			$currency = $_GET['currency']; //交易货币
			$hash_info = $_GET['hash_info']; //交易的加密信息
			$notification_url = $_GET['notification_url']; //网站即时通知URL)
			$info = $_GET['info']; //此时"info"字段的值为该笔交易失败的原因说明

			$mid = $model->getConfigData('mid');
			$site_id = $model->getConfigData('siteid');
			$api_key = $model->getConfigData('md5key');

			$getsignature = hash("sha256", $mid . $site_id .
				$oid . $Amount . $currency . $api_key);

			if ($getsignature != $hash_info) {
				die('Signature error!');
			}

			$order = Mage::getModel('sales/order')->loadByIncrementId($oid);
			if ($order_status == 2) { // 支付成功
				$order->addStatusToHistory($model->getConfigData('order_status_payment_success'), Mage::helper('ipasspay')->__('Payment Success!'), true);
				$order->save();
				//$this->_redirect('checkout/onepage/success');
			} elseif ($order_status == 6) { // 失败
				$_SESSION['message'] = $message;
				$order->addStatusToHistory($model->getConfigData('order_status'), Mage::helper('ipasspay')->__('Payment failure!'), true);
				$order->save();
				//$this->_redirect('checkout/onepage/failure');
			} elseif ($order_status == 1) { // Pending 未知
				if ($message == "") {
					$message = "Payment Failure";
				}
				$_SESSION['message'] = $message;
				//$this->_redirect('checkout/onepage/failure');
			}
		}
	}

	protected function saveInvoice(Mage_Sales_Model_Order $order) {
		if ($order->canInvoice()) {
			$convertor = Mage::getModel('sales/convert_order');
			$invoice = $convertor->toInvoice($order);
			foreach ($order->getAllItems() as $orderItem) {
				if (!$orderItem->getQtyToInvoice()) {
					continue;
				}
				$item = $convertor->itemToInvoiceItem($orderItem);
				$item->setQty($orderItem->getQtyToInvoice());
				$invoice->addItem($item);
			}
			$invoice->collectTotals();
			$invoice->register()->capture();
			Mage::getModel('core/resource_transaction')->addObject($invoice)->addObject($invoice->getOrder())->save();
			return true;
		}
		return false;
	}
}

